#!/usr/bin/python

import sys, os, math

# CHANGE THESE TO TEST WITH OTHER PAYOFF FUNCTIONS

def payoff_prv(x):
    return 3 * math.sin(t) * x

def payoffs_cpr(xs):
    if sum(xs) > nof_players * e / 2.0 :
        return 1, [-x for x in xs]     # tragedy
    else:
        return 0, [10*x for x in xs]


# HERE WE GO

nof_games, nof_rounds, nof_players, e = map(int, sys.argv[1:5])

# OPEN PIPES TO AND FROM PLAYERS

pos,pis = [],[]
for i in xrange(nof_players):
    pos.append(open("r2p.%d" % i, "w+",0))
    pis.append(file("p2r.%d" % i, "r"))


tots = [0.0]*nof_players

for g in xrange(nof_games):

    # AND LOOP NOF_ROUNDS

    for t in xrange(nof_rounds):

        # READ THE INPUT FROM PLAYERS
    
        xs = []
        for i,pi in enumerate(pis):
            try:
                xi = pi.readline()
                xs.append(int(xi))
                if xs[-1]<0 or xs[-1] > e:
                    xs[-1] = 0 # put all to private
                    raise "Improper investment"
            except:
                print >>sys.stderr, \
                      "ERROR: Player %d: '%s' not an integer between 0 and %d." \
                  % (i, xi.strip(), e)
                xs.append(0) # put all to private
            
        # CALCULATE PAYOFFS
    
        ups = map(payoff_prv, xs) # private
        trgdy, ucs = payoffs_cpr(xs)     # public

        # COMMUNICATE PAYOFFS TO PLAYERS

        sx = sum(xs)
        for i, po, up, uc in  zip(range(nof_players), pos, ups, ucs):
            print >>po, uc, up, sx, trgdy
            tots[i] += (1-trgdy)*(up + uc)

        if trgdy: break
        
# PRINT RESULTS

print "\n".join(map(str, tots))
